## dd-opentracing-cpp 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(dd-opentracing-cpp)

set(SOVERSION 0)

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

option(BUILD_SHARED "Builds shared library" ON)
option(BUILD_STATIC "Builds static library" OFF)
option(BUILD_PLUGIN "Builds plugin (requires gcc and not macos)" OFF)
option(BUILD_TESTING "Builds tests, also enables BUILD_SHARED" OFF)

if(BUILD_TESTING)
  set(BUILD_SHARED ON)
endif()

# Configure the compiler.
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()
set(CMAKE_CXX_STANDARD 14)

# Includes
set(CMAKE_INCLUDE_PATH 3rd_party/include deps/include)
include_directories(SYSTEM 3rd_party/include deps/include)
include_directories(include)

# Libraries
set(CMAKE_LIBRARY_PATH deps/lib)

# Dependencies
find_path(OPENTRACING_INCLUDE_DIR NAMES opentracing/tracer.h)
find_library(OPENTRACING_LIB opentracing)
find_package(ZLIB REQUIRED)
find_library(MSGPACK_LIB msgpack)
find_package(CURL)
find_package(Threads REQUIRED)

# Code Sanitizers
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/3rd_party/sanitizers-cmake" ${CMAKE_MODULE_PATH})
find_package(Sanitizers)

# Code
install(DIRECTORY include/datadog DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
file(GLOB DD_OPENTRACING_SOURCES "src/*.cpp")
message(STATUS "Compiler ID: ${CMAKE_CXX_COMPILER_ID}")
if((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  add_compile_options(-Wall -Wextra -Werror -pedantic -Wnon-virtual-dtor -Woverloaded-virtual -Wold-style-cast -std=c++14)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  add_compile_options(/W3)
else()
  message(FATAL_ERROR "Unknown compiler ${CMAKE_CXX_COMPILER_ID}")
endif()

# Outputs
set(DATADOG_LINK_LIBRARIES ${OPENTRACING_LIB} ${CURL_LIBRARIES} ${ZLIB_LIBRARIES} Threads::Threads)

## Shared lib
if(BUILD_SHARED)
  add_library(dd_opentracing SHARED ${DD_OPENTRACING_SOURCES})
  add_sanitizers(dd_opentracing)
  target_link_libraries(dd_opentracing ${DATADOG_LINK_LIBRARIES})
  set_target_properties(dd_opentracing PROPERTIES SOVERSION ${SOVERSION})
  target_compile_definitions(dd_opentracing PUBLIC DD_OPENTRACING_SHARED)
  install(TARGETS dd_opentracing
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

## Static lib
if(BUILD_STATIC)
  add_library(dd_opentracing-static STATIC ${DD_OPENTRACING_SOURCES})
  add_sanitizers(dd_opentracing-static)
  target_link_libraries(dd_opentracing-static ${DATADOG_LINK_LIBRARIES})
  set_target_properties(dd_opentracing-static PROPERTIES OUTPUT_NAME dd_opentracing POSITION_INDEPENDENT_CODE ON)
  target_compile_definitions(dd_opentracing-static PUBLIC DD_OPENTRACING_STATIC)
  install(TARGETS dd_opentracing-static
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

## Plugin
if(BUILD_PLUGIN)
  if(CMAKE_SYSTEM_NAME MATCHES "Darwin" OR NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message(FATAL_ERROR "Plugin cannot be built on Mac, and requires GCC")
  endif()

  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/export.map
      "{ global: OpenTracingMakeTracerFactory; local: *; };")
  add_library(dd_opentracing_plugin MODULE ${DD_OPENTRACING_SOURCES})
  target_link_libraries(dd_opentracing_plugin PUBLIC ${DATADOG_LINK_LIBRARIES}
                        -static-libstdc++
                        -static-libgcc
                        -Wl,--version-script=${CMAKE_CURRENT_BINARY_DIR}/export.map)
  install(TARGETS dd_opentracing_plugin
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Tests
include(CTest)
if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
add_library(catch STATIC test_main.cpp)

macro(_datadog_test TEST_NAME)
  add_executable(${TEST_NAME} ${ARGN})
  add_sanitizers(${TEST_NAME})  
  target_link_libraries(${TEST_NAME} dd_opentracing
                                     ${DATADOG_LINK_LIBRARIES}
                                     catch)
  add_test(${TEST_NAME} ${TEST_NAME})
endmacro()

_datadog_test(agent_writer_test agent_writer_test.cpp)
_datadog_test(opentracing_test opentracing_test.cpp)
_datadog_test(propagation_test propagation_test.cpp)
_datadog_test(sample_test sample_test.cpp)
_datadog_test(span_buffer_test span_buffer_test.cpp)
_datadog_test(span_test span_test.cpp)
_datadog_test(tracer_factory_test tracer_factory_test.cpp)
_datadog_test(tracer_options_test tracer_options_test.cpp)
_datadog_test(tracer_test tracer_test.cpp)
_datadog_test(limiter_test limiter_test.cpp)
_datadog_test(logger_test logger_test.cpp)

=== debian/changelog ===
dd-opentracing-cpp (1.3.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Stephen Gelman <ssgelm@debian.org>  Sat, 15 Jan 2022 17:07:46 -0600

dd-opentracing-cpp (1.3.1-1) unstable; urgency=medium

  * New upstream release

 -- Stephen Gelman <ssgelm@debian.org>  Sun, 07 Nov 2021 00:52:03 -0500

dd-opentracing-cpp (1.3.0-1) experimental; urgency=medium

  * Initial release (Closes: #991671)

 -- Stephen Gelman <ssgelm@debian.org>  Thu, 15 Jul 2021 23:05:10 -0500

=== debian/control ===
Source: dd-opentracing-cpp
Priority: optional
Maintainer: Stephen Gelman <ssgelm@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libopentracing-dev,
               libcurl4-nss-dev,
               zlib1g-dev,
               libmsgpack-dev,
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/DataDog/dd-opentracing-cpp
Vcs-Browser: https://salsa.debian.org/ssgelm/dd-opentracing-cpp
Vcs-Git: https://salsa.debian.org/ssgelm/dd-opentracing-cpp.git
Rules-Requires-Root: no

Package: libdd-opentracing-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdd-opentracing0 (= ${binary:Version}), ${misc:Depends}
Description: Datadog OpenTracing C++ Client (headers)
 An OpenTracing client to collect OpenTracing data in a format that can be
 parsed locally by Datadog's agent. This is used as a plugin in conjunction
 with lib-opentracing1 in applications that support OpenTracing.
 .
 This package contains the development headers for libdd-opentracing0.

Package: libdd-opentracing0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Datadog OpenTracing C++ Client (lib)
 An OpenTracing client to collect OpenTracing data in a format that can be
 parsed locally by Datadog's agent. This is used as a plugin in conjunction
 with lib-opentracing1 in applications that support OpenTracing.
 .
 This package contains the library for libdd-opentracing0 along with the plugin
 version.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTING=ON -DBUILD_PLUGIN=ON

## dd-opentracing-cpp 1.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.13)
 
 project(dd-opentracing-cpp)
 
@@ -12,8 +12,10 @@
 
 option(BUILD_SHARED "Builds shared library" ON)
 option(BUILD_STATIC "Builds static library" OFF)
+option(BUILD_OBJECT "Builds objects for use in another project" OFF)
 option(BUILD_PLUGIN "Builds plugin (requires gcc and not macos)" OFF)
 option(BUILD_TESTING "Builds tests, also enables BUILD_SHARED" OFF)
+option(BUILD_COVERAGE "Builds code with code coverage profiling instrumentation" OFF)
 
 if(BUILD_TESTING)
   set(BUILD_SHARED ON)
@@ -26,7 +28,6 @@
 set(CMAKE_CXX_STANDARD 14)
 
 # Includes
-set(CMAKE_INCLUDE_PATH 3rd_party/include deps/include)
 include_directories(SYSTEM 3rd_party/include deps/include)
 include_directories(include)
 
@@ -36,7 +37,6 @@
 # Dependencies
 find_path(OPENTRACING_INCLUDE_DIR NAMES opentracing/tracer.h)
 find_library(OPENTRACING_LIB opentracing)
-find_package(ZLIB REQUIRED)
 find_library(MSGPACK_LIB msgpack)
 find_package(CURL)
 find_package(Threads REQUIRED)
@@ -51,6 +51,9 @@
 message(STATUS "Compiler ID: ${CMAKE_CXX_COMPILER_ID}")
 if((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
   add_compile_options(-Wall -Wextra -Werror -pedantic -Wnon-virtual-dtor -Woverloaded-virtual -Wold-style-cast -std=c++14)
+  if(BUILD_COVERAGE)
+      add_compile_options(-g -O0 -fprofile-arcs -ftest-coverage)
+  endif()
 elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
   add_compile_options(/W3)
 else()
@@ -58,12 +61,18 @@
 endif()
 
 # Outputs
-set(DATADOG_LINK_LIBRARIES ${OPENTRACING_LIB} ${CURL_LIBRARIES} ${ZLIB_LIBRARIES} Threads::Threads)
+if(BUILD_COVERAGE)
+  set(COVERAGE_LIBRARIES gcov)
+endif()
+set(DATADOG_LINK_LIBRARIES ${OPENTRACING_LIB} ${CURL_LIBRARIES} Threads::Threads ${COVERAGE_LIBRARIES})
 
 ## Shared lib
 if(BUILD_SHARED)
   add_library(dd_opentracing SHARED ${DD_OPENTRACING_SOURCES})
   add_sanitizers(dd_opentracing)
+  if(BUILD_COVERAGE)
+    target_link_options(dd_opentracing PRIVATE -fprofile-arcs -ftest-coverage)
+  endif()
   target_link_libraries(dd_opentracing ${DATADOG_LINK_LIBRARIES})
   set_target_properties(dd_opentracing PROPERTIES SOVERSION ${SOVERSION})
   target_compile_definitions(dd_opentracing PUBLIC DD_OPENTRACING_SHARED)
@@ -84,6 +93,15 @@
           ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
 endif()
 
+## Object lib
+if(BUILD_OBJECT)
+  add_library(dd_opentracing-object OBJECT ${DD_OPENTRACING_SOURCES})
+  add_sanitizers(dd_opentracing-object)
+  target_link_libraries(dd_opentracing-object ${CURL_LIBRARIES} Threads::Threads)
+  set_property(TARGET dd_opentracing-object PROPERTY POSITION_INDEPENDENT_CODE ON)
+  target_compile_definitions(dd_opentracing-object PUBLIC DD_OPENTRACING_OBJECT)
+endif()
+
 ## Plugin
 if(BUILD_PLUGIN)
   if(CMAKE_SYSTEM_NAME MATCHES "Darwin" OR NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
@@ -93,6 +111,9 @@
   file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/export.map
       "{ global: OpenTracingMakeTracerFactory; local: *; };")
   add_library(dd_opentracing_plugin MODULE ${DD_OPENTRACING_SOURCES})
+  if(BUILD_COVERAGE)
+    target_link_options(dd_opentracing_plugin PRIVATE -fprofile-arcs -ftest-coverage)
+  endif()
   target_link_libraries(dd_opentracing_plugin PUBLIC ${DATADOG_LINK_LIBRARIES}
                         -static-libstdc++
                         -static-libgcc

=== debian/changelog ===
dd-opentracing-cpp (1.3.6-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS on riscv64 (Closes: #1022112)
    Thanks to JunYuan Tan for the patch!

 -- Stephen Gelman <ssgelm@debian.org>  Mon, 24 Oct 2022 10:34:12 -0500

dd-opentracing-cpp (1.3.1-3) unstable; urgency=medium

  * Change dep from libmsgpack-dev to libmsgpack-cxx-dev (Closes: #1019111)
  * Update standards version to 4.6.1.0

 -- Stephen Gelman <ssgelm@debian.org>  Tue, 11 Oct 2022 19:04:39 -0500

dd-opentracing-cpp (1.3.1-2) unstable; urgency=medium

  * Update catch2 dependency to fix FTBFS with glibc >= 2.34 (Closes: #1009662)
    Thanks to Steve Langasek for the patch!
  * Add patch to fix FTBFS in span_test
  * Update standards version to 4.6.0.1

 -- Stephen Gelman <ssgelm@debian.org>  Sun, 24 Apr 2022 19:40:49 -0500

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
                libopentracing-dev,
                libcurl4-nss-dev,
                zlib1g-dev,
-               libmsgpack-dev,
-Standards-Version: 4.5.1
+               libmsgpack-cxx-dev,
+Standards-Version: 4.6.1.0
 Section: libs
 Homepage: https://github.com/DataDog/dd-opentracing-cpp
 Vcs-Browser: https://salsa.debian.org/ssgelm/dd-opentracing-cpp

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,10 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+ifeq ($(DEB_HOST_ARCH),riscv64)
+	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
 
 %:
 	dh $@

## dd-opentracing-cpp 1.3.7

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,9 @@
 macro(_datadog_test TEST_NAME)
   add_executable(${TEST_NAME} ${ARGN})
   add_sanitizers(${TEST_NAME})  
+  if(BUILD_COVERAGE)
+    target_link_options(${TEST_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
+  endif()
   target_link_libraries(${TEST_NAME} dd_opentracing
                                      ${DATADOG_LINK_LIBRARIES}
                                      catch)
@@ -15,8 +18,10 @@
 _datadog_test(sample_test sample_test.cpp)
 _datadog_test(span_buffer_test span_buffer_test.cpp)
 _datadog_test(span_test span_test.cpp)
+_datadog_test(tag_propagation_test tag_propagation_test.cpp)
 _datadog_test(tracer_factory_test tracer_factory_test.cpp)
 _datadog_test(tracer_options_test tracer_options_test.cpp)
 _datadog_test(tracer_test tracer_test.cpp)
 _datadog_test(limiter_test limiter_test.cpp)
 _datadog_test(logger_test logger_test.cpp)
+_datadog_test(glob_test glob_test.cpp)

=== 3rd_party/include/catch2/Makefile ===
.PHONY: all
all: catch.hpp LICENSE.txt

catch.hpp:
	wget 'https://github.com/catchorg/Catch2/releases/download/v2.13.9/catch.hpp'

LICENSE.txt:
	wget 'https://raw.githubusercontent.com/catchorg/Catch2/v2.x/LICENSE.txt'

=== 3rd_party/include/nlohmann/Makefile ===
.PHONY: all
all: json.hpp LICENSE.MIT

json.hpp:
	wget 'https://github.com/nlohmann/json/releases/download/v3.11.2/json.hpp'

LICENSE.MIT:
	wget 'https://raw.githubusercontent.com/nlohmann/json/v3.11.2/LICENSE.MIT'

=== debian/changelog ===
dd-opentracing-cpp (1.3.7-1) unstable; urgency=medium

  * New upstream release
  * Replace libcurl4-nss-dev dep with libcurl4-openssl-dev (Closes: #1038909)
  * Update standards version to 4.6.2

 -- Stephen Gelman <ssgelm@debian.org>  Sun, 13 Aug 2023 23:48:41 -0500

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libopentracing-dev,
-               libcurl4-nss-dev,
+               libcurl4-openssl-dev,
                zlib1g-dev,
                libmsgpack-cxx-dev,
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/DataDog/dd-opentracing-cpp
 Vcs-Browser: https://salsa.debian.org/ssgelm/dd-opentracing-cpp

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dd-opentracing-cpp-$1.tar.gz%" \
   https://github.com/DataDog/dd-opentracing-cpp/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
